//+------------------------------------------------------------------+
//|                                       for FTS MA  otlopnenie.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


extern bool sistems2=false;
extern bool bool_total_orders=true;
extern int total_orders=3;
extern bool bool_stop=true;
extern int stop=900;
extern bool bool_steps_closing=true;
extern int cl_prc1=30;
extern int cl_pip=400;
extern bool bool_lot_for_loss=true;
extern double k_minus=1.8;
extern double lot=0.11;
extern bool avtolot=true;
double up=0;
double dw=0;
extern bool bool_nul_stop=true;
extern int nul_stop=400;
extern int blok=500;

extern int periodMA=15;
extern int otlonenie=300;
int ma_shift=0;
int ma_method=0;
int applied_price=0;
int shift=0;
int s;
extern bool everi_tik=true;
 

string glstri="";

void cl() 
   {
   ////maks pip
   //     cl_prc1 -     
   double procent=(1-(cl_prc1*0.01)); //       1- 
   double cl_prc=cl_prc1*0.01;  //      
   for (int i=0; i<=OrdersTotal(); i++)//  
       {
       if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
          {
          double pip=0.0;
         // double pip=OrderProfit()/(OrderLots()*8)*5; //  
         //  
          if (OrderType()==0)   {pip=(Ask-OrderOpenPrice())*(1/Point);}
          if (OrderType()==1)   {pip=(OrderOpenPrice()-Bid)*(1/Point);}
          
          if (bool_stop) if (pip<stop*(-1)) {
             if (OrderType()==OP_BUY)  OrderClose(OrderTicket(),OrderLots(),Bid,0,Gold);
             if (OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,0,Gold);} //..    
          
          if (bool_nul_stop) if (pip>nul_stop) if (OrderStopLoss()!=OrderOpenPrice()) {OrderModify(OrderTicket(), OrderOpenPrice(), OrderOpenPrice(), 0, 0, Blue);} //..   
          
          
          double x1=0;
          if (bool_steps_closing)//        
             for (int c=7; c>=1; c--)
              {
              if (pip>cl_pip*c) //  
                 {
                 if (OrderLots()>lot*MathPow(procent,c)) // 
                    {
                    x1=NormalizeDouble(OrderLots()*cl_prc,2);
                    if (x1<0.02 || c==7) x1=OrderLots(); 
                    if (OrderType()==OP_BUY)  OrderClose(OrderTicket(),x1,Bid,0,Gold);
                    if (OrderType()==OP_SELL) OrderClose(OrderTicket(),x1,Ask,0,Gold);
                    }
                 }
              }
          }
       }
   }


double anti(double in=-1, bool sis=0)//    ...      
   {
   if (sis)
      {
      if (in==0) return(1);
      if (in==1) return(0);
      }
   return(in);
   }

void cl_na(int sis=-1)//    
   {
   for (int i=0; i<=OrdersTotal(); i++)
       {
       if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
          {
          if (sis==OrderType()) 
             {
             if (OrderType()==OP_BUY)  OrderClose(OrderTicket(),OrderLots(),Bid,0,Gold);
             if (OrderType()==OP_SELL) OrderClose(OrderTicket(),OrderLots(),Ask,0,Gold);
             }
          }
       } 
      
      
   }

int samMA()//      
   {
  // glstri=StringConcatenate(glstri,,"\n");
   double ma=iMA(Symbol(),0,periodMA,ma_shift,ma_method,applied_price,shift);
   glstri=StringConcatenate(glstri,     "  ma=",ma,";"    ,"\n");
   glstri=StringConcatenate(glstri,     "  otlonenie*Point=",otlonenie*Point,";"    ,"\n");
   if (sistems2)  // -  
      {
      if (ma<iOpen(Symbol(),0,0) && dw==0) up=0;
      if (ma>iOpen(Symbol(),0,0) && up==0) dw=0;
      }
   if (!everi_tik) if (ma+otlonenie*Point<iOpen(Symbol(),0,0)) return(0);
   if (everi_tik)  if (ma+otlonenie*Point<Bid) return(0);
   if (!everi_tik) if (ma-otlonenie*Point>iOpen(Symbol(),0,0)) return(1);
   if (everi_tik)  if (ma-otlonenie*Point>Ask) return(1);
   return(-1);
   }

int signal()
   {
   //static int bar=0; if (bar==Bars) return(0); bar=Bars;
   if (AccountBalance()>AccountEquity()) lot=NormalizeDouble(av_lot()*k_minus,2);//      
   
   
   //  
   int si1=anti(samMA(),1);
   int tik=0;
   if (si1==0 && (up+blok*Point<Ask || up-blok*Point>Ask)) 
      {  
      if (bool_total_orders) {if (OrdersTotal()<total_orders || dw!=0) tik=OrderSend(Symbol(),0,NormalizeDouble(lot,2),Ask,0,0,0,0,0,0,Green);}
      else   tik=OrderSend(Symbol(),0,NormalizeDouble(lot,2),Ask,0,0,0,0,0,0,Green); 
         if (tik>0) {up=Ask; dw=0;} 
      }
   if (si1==1 && (dw+blok*Point<Ask || dw-blok*Point>Ask)) 
      {  
      if (bool_total_orders) {if (OrdersTotal()<total_orders || up!=0)  tik=OrderSend(Symbol(),1,NormalizeDouble(lot,2),Bid,0,0,0,0,0,0,Red);}
      else   tik=OrderSend(Symbol(),1,NormalizeDouble(lot,2),Bid,0,0,0,0,0,0,Red);
         if (tik>0) {dw=Bid; up=0;} 
      } 
   if (dw==0) cl_na(1);
   if (up==0) cl_na(0);
   //   
   
    
   return(0);
   } 
double av_lot()
   {
   if (!avtolot) return(lot);
   static double st_balans=0;
   static double st_lot=0.0;
   if (st_lot==0.0) st_lot=lot;
   if (st_balans==0) st_balans=AccountBalance();
   
   double nw_lot=NormalizeDouble(((AccountBalance()/st_balans)*st_lot),2);
   glstri=StringConcatenate(glstri,     "  nw_lot=",nw_lot,"; ",st_lot,"; ",lot,"; "   ,"\n");
   if (nw_lot>20.0) return(20);
   else return(nw_lot);
   }


int start()
  {
  glstri="t ";
//----
   if (avtolot) lot=av_lot();
   signal();
   
   if (avtolot) lot=av_lot();
   cl();
//----
 static double prosadka=200.2;
  if ((AccountEquity()*100)/AccountBalance()<prosadka) prosadka=(AccountEquity()*100)/AccountBalance();
  Comment(glstri,"  ",lot," prosadka=",prosadka);
   static double ac_eq_st=0.000001;
   if (ac_eq_st==0.000001) ac_eq_st=AccountEquity();
   GlobalVariableSet("  -  ",AccountEquity()-ac_eq_st);
   return(0);
  }
//+------------------------------------------------------------------+